# Copyright (C) 2016-2024 RhodeCode GmbH
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License, version 3
# (only), as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This program is dual-licensed. If you wish to learn more about the
# RhodeCode Enterprise Edition, including its added features, Support services,
# and proprietary license terms, please see https://rhodecode.com/licenses/

import os

from pyramid.paster import bootstrap as pyramid_bootstrap, setup_logging  # pragma: no cover
from pyramid.threadlocal import get_current_request as pyramid_current_request


def bootstrap(config_uri, options=None, env=None):
    from rhodecode.config.utils import DEFAULT_USER
    from rhodecode.lib.config_utils import get_app_config_lightweight
    from rhodecode.lib.utils2 import AttributeDict
    from rhodecode.lib.request import Request
    from rhodecode.config.settings_maker import initialize_ini_config_default_values_if_not_present, generate_token

    if env:
        os.environ.update(env)

    initialize_ini_config_default_values_if_not_present(
        ini_path=config_uri, option="app.service_api.token", default_val=generate_token()
    )
    config = get_app_config_lightweight(config_uri)
    base_url = config["app.base_url"]

    request = Request.blank("/", base_url=base_url)
    # fake inject a running user for bootstrap request !
    request.user = AttributeDict({"username": DEFAULT_USER, "user_id": 1, "ip_addr": "127.0.0.1"})
    return pyramid_bootstrap(config_uri, request=request, options=options)


def get_current_request():
    pyramid_req = pyramid_current_request()
    if not pyramid_req:
        # maybe we're in celery context and need to get the PYRAMID_REQUEST
        from rhodecode.lib.celerylib.loader import celery_app

        pyramid_req = celery_app.conf.get("PYRAMID_REQUEST")
    return pyramid_req
